
/// 2-D finite-difference gradient
///Yang Zhang
///Modified from RSF program below

/*
  Copyright (C) 2004 University of Texas at Austin

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "stdafx.h"
#include "op.h"
#include "igrad2op.h"
#include "sergey_rsf.h"


/*
namespace Yang {
  
class igrad2op: public op{
  public:
  void init (int n1_, int n2_) {
    n1 = n1_;
    n2 = n2_;
  }

  virtual int oper(bool adj,bool add, std::valarray<float>& mod, std::valarray<float>& dat);
protected:
  int n1,n2;
};

class igrad3op:public op{
  public:
  void init (int n1_, int n2_, int n3_) {
    n1 = n1_;
    n2 = n2_; n3 = n3_;
  }

  virtual int oper(bool adj,bool add, std::valarray<float>& mod, std::valarray<float>& dat);
protected:
  int n1,n2,n3;
};
}

using namespace Yang;

int igrad2op::oper(bool adj,bool add, std::valarray<float>& mod, std::valarray<float>& dat)
// linear operator, dat[n1*n2*2] is the gradient of mod[n1*n2] 
{
    int i1,i2,i;

    uint n12 = n1*n2;
    VERIFY(mod.size() == n12);
    VERIFY(dat.size() == n12*2)

  //Take out the memory ptr of mod and dat, then
  float *p = mod(0); float *r = dat(0);
  sf_adjnull (adj,add,np,nr,p,r);

  uint ind1,ind2;

  for (i2=0; i2 < n2-1; i2++) {
	for (i1=0; i1 < n1-1; i1++) {
    ind1 = IND2(i1,i2,n1);
    ind2 = ind1 + n12;
    if (adj) {
		p[ind1+1]  += r[ind1];
		p[ind1+n1] += r[ind2];
		p[ind1]    -= (r[ind1] + r[ind2]);
    } else {
		r[ind1]    += (p[ind1+1]  - p[ind1]);
		r[ind2]    += (p[ind1+n1] - p[ind1]);
    }
	}
  }
  return 0;
}

int igrad3op::oper(bool adj,bool add, valarray<float>& mod, valarray<float>& dat)
// linear operator, dat[n1*n2*n3*3] is the gradient of mod[n1*n2*n3]
{
  int i1,i2,i3,n123;

  uint n123 = n1*n2*n3;
  VERIFY(mod.size() == n123);
  VERIFY(dat.size() == n123*3)

  //Take out the memory ptr of mod and dat, then
  float *p = mod(0); float *r = dat(0);
  sf_adjnull (adj,add,np,nr,p,r);

  uint ind1,ind2,ind3;
  uint n12 = n1*n2;
  for (i3=0; i3 < n3-1; i3++) {
  for (i2=0; i2 < n2-1; i2++) {
	for (i1=0; i1 < n1-1; i1++) {
    ind1 = (i3*n2+i2)*n1+i1;
    ind2 = ind1 + n123;
    ind3 = ind2 + n123;
    if (adj) {
		p[ind1+1]   += r[ind1];
		p[ind1+n1]  += r[ind2];
		p[ind1+n12] += r[ind3];
		p[ind1]     -= (r[ind1] + r[ind2] + r[ind3]);
    } else {
		r[ind1]    += (p[ind1+1]    - p[ind1]);
		r[ind2]    += (p[ind1+n1]   - p[ind1]);
		r[ind3]    += (p[ind1+n12]  - p[ind1]);
    }
	}
  }
  }
  return 0;
}


*/

