#ifndef __MISC_H_INCL__
#define __MISC_H_INCL__

#include "interp.h"

namespace seplib {
void callSepTool(Yang::cubeData<float>& outCube, const Yang::cubeData<float>& inCube, 
                 const std::string& toolName, const std::string& par,bool bAllocOutMemInside = false);

// Does OFF2ANG transform, if binverse=1 then does ANG to OFF transform
// 2D transform, The axis arrangement is (z,hx,x) <--> (z,ax,x)
// cube_transp is the variable for intermediate transpose result.
void off2ang(Yang::cubeData<float>& outCube, Yang::cubeData<float>& inCube, bool bInverse, float a_h_max);
};

namespace Yang {
  //for FFT axis
inline void get_axis_inv(axis& ax_out, int n_out, const axis& ax_in) {
    char sztmp[512];
    sprintf(sztmp,"1/%s",ax_in.label.c_str()); ax_out.label= sztmp;
    sprintf(sztmp,"1/%s",ax_in.unit.c_str());  ax_out.unit = sztmp;
    ax_out.o = 0.0f; ax_out.n = n_out; ax_out.d = 1.f/(ax_out.n * ax_in.d);
  }
}
#endif
