#ifndef OP_H
#define OP_H

#include "hypercube.h"
#include "gVec.h"

namespace Yang {

class op  //Define the class of operator
{
public:
	//The user should make sure that the shape in mod and dat is consistent of the members
	//modShape and datShape

  virtual void oper(cubeData<float>& mod, cubeData<float>& dat, bool bAdj, bool bAdd) {VERIFY(0);}
    
  bool dot_test(bool verbose=1);
   
  virtual ~op() {
  }
  
  const hypercube& getModShape() const {
    return modShape;
  }
  const hypercube& getDatShape() const  {
    return datShape;
  }
  
protected:  
  hypercube modShape, datShape;
  
protected:
  void setShape(const hypercube& _modSh, const hypercube& _datSh) {
    modShape = _modSh;
    datShape = _datSh;
  }
};
}

#endif
