#ifndef STD_AFX__C__H
#define STD_AFX__C__H

#include <stdlib.h>
extern "C" {
#include <seplib.h>
#include <sep3d.h>
}
#include <assert.h>
#include <math.h>

//MACRO CONSTS
#define MAX_CHAR_BUF 4096

//array indexing
#define IND2(i1,i2,n1) ((i2)*(n1)+(i1))
#define IND3(i1,i2,i3,n1,n2) (((i3)*(n2)+(i2))*(n1)+(i1))

extern bool gVerb; //if verbose
extern int gVerbLevel; //if verbose
extern bool gIsLogging; //if enable logging


void verbPrt(const char* form, ...);
void verbPrt(int verbLevel, const char* form, ...);
void prt(const char* form,...);
void dbPrt(const char* form,...);

//print the error and exit
void errPrt(const char* form,...);

#define LOGC(word) \
	if (gIsLogging) \
		{fprintf(stderr,"\n%s:%d;  %s" ,__FILE__, __LINE__,#word);}


#define VERIFYC(S) {   \
  if(!(S))   \
   {  \
   fprintf(stderr,"\n%s:%d;!! %s Did not pass verify",__FILE__,__LINE__,#S); \
	  abort();\
	  exit(0); \
   }}
    
#endif
