% Plot the offset to angle mapping diagram
%% Init, first case
set(0,'DefaultTextFontSize',14);
set(0,'DefaultAxesFontSize',14);

dx = 1; dy = 1; dz = 1; dhx = 1; dhy = 1;
kx = 1/dx * 1/8; % pi/4 frequency, 1/4 of the maximum allowed freq
ky = 1/dy * 1/8;
kz = 1/dz * 1/4;
dkhx = 1/dhx/32; dkhx_max = 0.5/dhx;

phid = [-60:7.5:60]; phi = phid * pi/180;
gammad = [-70:2.5:70];  gamma = gammad * pi/180;


%% Do the mapping
kxy = [kx; ky];
kxyp = kxy; 
khxyp = kxy; khxy = kxy;

[gammas,phis] = meshgrid(gammad,phid);
khxs = zeros(size(gammas));
khys = zeros(size(gammas));

for ip = 1:1:length(phi)
  phii = phi(ip);
  mrot  = [cos(phii) -sin(phii); sin(phii) cos(phii)];
  mroti = [cos(phii)  sin(phii);-sin(phii) cos(phii)];
  kxyp = mrot*kxy;
  kyz_sqsum = kxyp(2).*kxyp(2) + kz*kz;
  kyz_sqsumrt = sqrt(kyz_sqsum);
  for ig = 1:length(gamma)
    tanga = tan(gamma(ig));
    khxp = tanga*kyz_sqsumrt;
    khxyp = [khxp;  kxyp(1)*kxyp(2)*khxp/(kyz_sqsum)];
    khxy =  mroti * khxyp;
    khxs(ip,ig) = khxy(1);
    khys(ip,ig) = khxy(2);
  end
end



 %scatter(gammas(:),phis(:));

% 
%figure;
%scatter(khxs(:),khys(:),20,'fill'); xlabel('k_{hx}');ylabel('k_{hy}');

khxscor = khxs(1:2:end,1:2:end); khxscen = khxs(2:2:end,2:2:end);
khyscor = khys(1:2:end,1:2:end); khyscen = khys(2:2:end,2:2:end);

phiscor = phis(1:2:end,1:2:end); phiscen = phis(2:2:end,2:2:end);
gammascor = gammas(1:2:end,1:2:end); gammascen = gammas(2:2:end,2:2:end);

%%  Plot the mappings
mesh(khxscor,khyscor,zeros(size(khxscor))); view(0,90); colormap autumn;
xlabel('k_{hx}(f_{Nyq})');ylabel('k_{hy}(f_{Nyq})');
hold on; scatter(khxscen(:),khyscen(:),20,'fill'); 
%%
figure;
mesh(gammascor,phiscor,zeros(size(gammascor))); view(0,90);colormap winter;
xlabel('\gamma(deg)'); ylabel('\phi(deg)'); axis([-90 90 -90 90]);
hold on; scatter(gammascen(:),phiscen(:),20,'fill');

%% Test a new case
